<id>
Users Online Counter - English
</id>

<version>
1.2
</version>

<mod info>
You want to know how much users are connected to your board but you don't want to count them yourself? Install this mod and it shows you how much are on your board.

V1.1:
- now it saves and displays (if it's turned on) what the day was with the most
  users and how much users were online
- you can now disable the whole Users Online Bar from Admin Center
- if guestaccess is turned off "Guests" will not be displayed and counted
  to the online counter file

V1.2:
- shows what a user is doing on the board
- shows a link to the online overview optional for all user or just admins
- shows the ips of the users to the admins in the online overview
- admin actions can be hidden for other users

Credits:
The Online Overview is originally done by DaddyCool.
I just converted it to YaBB 1 Gold and edited some things and
added some options.

</mod info>

<author>
dOCda S!
</author>

<homepage>
http://gpu.hackers.sk/hacks/index.htm
</homepage>

<edit file>
Sources/BoardIndex.pl
</edit file>

<search for>
	$guests = 0;
	$users = '';
</search for>

<replace>
	$guests = 0;
	$counter = 0;
	$users = '';
</replace>

<search for>
			if( exists $userprofile{$name} ) {
				$users .= qq~ <a href="$scripturl?action=viewprofile&username=$useraccount{$name}">$userprofile{$name}->[1]</a><font size=1>,</font> \n~;
</search for>

<add after>
			$counter++;
</add after>

<search for>
	if( $username ne 'Guest' ) {
		$messnum = @immessages;
</search for>

<add after>
if ($guestaccess != 0) {
$countonl = $counter + $guests;
$uguest = qq($guests $txt{'141'}<br>);
} else { $countonl = $counter; }
open(FILE, "$vardir/mostuser.txt");
@onlcount = <FILE>;
close(FILE);
if ($countonl > $onlcount[0]) {
fopen(FILE, ">$vardir/mostuser.txt");
print FILE "$countonl\n";
print FILE "$date";
fclose(FILE);
}
$onlcount[1] = &timeformat($onlcount[1]);
if ($onlopt == 1 || $onlopt == 2 && $settings[7] eq "Administrator") {
if ($countonl == 1) { $uwhoonline = qq(&#187; <a href="$scripturl?action=who">$who{'99'} ($countonl) $who{'100'}</a> &#171;<br>); }
else { $uwhoonline = qq(&#187; <a href="$scripturl?action=who">$who{'98'} ($countonl) $who{'100'}</a> &#171;<br>); }
}
if ($Show_MostUsers == 1) {
$uonline = qq(<br><br>$mosttxt{'01'} $onlcount[1] $mosttxt{'02'} $onlcount[0] $mosttxt{'03'});
}
</add after>

<search for>
	print <<"EOT";
  <tr>
    <td class="catbg" bgcolor="$color{'catbg'}" colspan="2"><font size="2" class="catbg">&#187; <b>$txt{'158'}</b></font></td>
  </tr><tr>
    <td class="windowbg" bgcolor="$color{'windowbg'}" width="20" valign="middle" align="center"><img src="$imagesdir/online.gif" border="0"></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size=2>$txt{'141'}: $guests <br>$txt{'142'}: $users</font></td>
  </tr>
EOT
</search for>

<replace>
	if($Show_OnlineBar == 1 || $Show_OnlineBar eq "") {
	print <<"EOT";
  <tr>
    <td class="catbg" bgcolor="$color{'catbg'}" colspan="2"><font size="2" class="catbg">&#187; <b>$txt{'158'}</b></font></td>
  </tr><tr>
    <td class="windowbg" bgcolor="$color{'windowbg'}" width="20" valign="middle" align="center"><img src="$imagesdir/online.gif" border="0"></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size=2>$uwhoonline$uguest $counter $txt{'142'}: $users $uonline</font></td>
  </tr>
EOT
}
</replace>

<edit file>
Sources/Admin.pl
</edit file>

<search for>
	if ($Show_MemberBar) { $smbarchecked = "checked" }
</search for>

<add after>
	if ($Show_OnlineBar || $Show_OnlineBar eq "") { $onlbarchecked = "checked" }
	if ($Show_MostUsers) { $smuchecked = "checked" }
	if ($onlopt == 0) { $whooff = "checked" } elsif ($onlopt == 1) { $whoon = "checked" } elsif ($onlopt == 2) { $whoadmins = "checked" }
	if ($adminwho) { $admindisplay = "checked" }
</add after>

<search for>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'510'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="showmemberbar" $smbarchecked></td>
  </tr><tr>
</search for>

<add before>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$mosttxt{'04'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="showonlinebar" $onlbarchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$mosttxt{'05'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="showmostusers" $smuchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$who{'101'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><INPUT TYPE=radio name="onlopt" VALUE="0" $whooff></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$who{'102'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><INPUT TYPE=radio name="onlopt" VALUE="1" $whoon></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$who{'103'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><INPUT TYPE=radio name="onlopt" VALUE="2" $whoadmins></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$who{'104'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="adminwho" $admindisplay></td>
  </tr><tr>
</add before>

<search for>
	# Set as 0 or 1 if box was checked or not
	my $fi;
</search for>

<add before>
	push(@onoff, "showonlinebar", "showmostusers", "onlopt", "adminwho");
</add before>

<search for>
	$timeout = $FORM{'timeout'} || 0;
</search for>

<add before>
	$onlopt = $FORM{'onlopt'} || 0;
</add before>

<search for>
\$Show_MemberBar = $showmemberbar;			# Set to 1 to display the Members List table row on Board Index
</search for>

<add after>
\$Show_OnlineBar = $showonlinebar;			# Set to 1 to display the Who's Online List table row on Board Index
\$Show_MostUsers = $showmostusers;			# Set to 1 to display the Line with Most Users Online in the Who's Online List
\$onlopt = $onlopt;					# Set to 1 to enable Online Overview to all, 2 for just Admins, 0 for disable
\$adminwho = $adminwho;					# Set to 1 to disable the admin actions display in the Online Overview
</add after>

<edit file>
english.lng
</edit file>

<search for>
$txt{'749'} = "The 'number of posts' box can only contain digits.";
</search for>

<add after>
$mosttxt{'01'} = "The day with the most Users online was";
$mosttxt{'02'} = "with";
$mosttxt{'03'} = "Users!";
$mosttxt{'04'} = "Show Who's Online List Bar on Board Index?";
$mosttxt{'05'} = "Display Most Users Online Info in Who's Online?";
$who{'1'} = "Name";
$who{'2'} = "Who's online?";
$who{'3'} = "Date/Time";
$who{'4'} = "Action";
$who{'5'} = "views currently the";
$who{'6'} = "forum index";
$who{'7'} = ".";
$who{'8'} = "is currently viewing the forum";
$who{'9'} = "is currently viewing who is";
$who{'10'} = "online";
$who{'11'} = ".";
$who{'12'} = "uses currently the ICQ Pager.";
$who{'13'} = "sends his password to his account.";
$who{'14'} = "saves the preferences.";
$who{'15'} = "edits the optical preferences.";
$who{'16'} = "posts a new thread in the forum";
$who{'17'} = "replies to the thread";
$who{'18'} = "in the forum";
$who{'19'} = "is currently viewing the thread";
$who{'20'} = "copies the thread";
$who{'21'} = "as print version.";
$who{'22'} = "edits the censored words.";
$who{'23'} = "saves the censored words.";
$who{'24'} = "edits the news.";
$who{'25'} = "edits the news.";
$who{'26'} = "moves a thread.";
$who{'27'} = "is currently (un)subscribing the notify of";
$who{'28'} = ".";
$who{'29'} = "is removing old threads.";
$who{'30'} = "locks the thread";
$who{'31'} = "is currently registering.";
$who{'32'} = "is viewing the";
$who{'33'} = "agreement letter";
$who{'34'} = "is viewing the";
$who{'35'} = "help";
$who{'36'} = "is logging in.";
$who{'37'} = "has logged out.";
$who{'38'} = "removes a thread.";
$who{'39'} = "modifies the thread";
$who{'40'} = "modifies his own profile.";
$who{'41'} = "modifies the profile of";
$who{'42'} = "is trying to modify the profile of";
$who{'43'} = ".";
$who{'44'} = "is currently viewing the profile of";
$who{'45'} = "edits a category.";
$who{'46'} = "is reordering the categories.";
$who{'47'} = "deletes a category.";
$who{'48'} = "creates a new category.";
$who{'49'} = "edits a forum.";
$who{'50'} = "is reordering the forums.";
$who{'51'} = "creates a new forum.";
$who{'52'} = "is currently in the Admin Center.";
$who{'53'} = "views currently all members.";
$who{'54'} = "writes a massmail to all members.";
$who{'55'} = "edits the membergroups.";
$who{'56'} = "checks currently his Instant Messages.";
$who{'57'} = "changes the Preferences for his Instant Messages.";
$who{'58'} = "views the outbox in his Instant Messages.";
$who{'59'} = "deletes an Instant Message.";
$who{'60'} = "writes an Instant Message.";
$who{'61'} = "sends an Instant Message.";
$who{'62'} = "views the Members List.";
$who{'63'} = "views the Members List sorted by letters.";
$who{'64'} = "views the list of the Top Posters.";
$who{'65'} = "views/edits the list of reserved names.";
$who{'66'} = "saves the list of reserved names.";
$who{'67'} = "marks the threads in Forum $boardname as read.";
$who{'68'} = "uses the search function.";
$who{'69'} = "is checking for updates.";
$who{'70'} = "is currently viewing the Memberslist through the Admin Center.";
$who{'71'} = "deletes the Log-File.";
$who{'72'} = "is currently in the Global Mods Center.";
$who{'73'} = "edits the preferences.";
$who{'74'} = "marks the whole board as read.";
$who{'75'} = "recounts the memberships.";
$who{'76'} = "views the recent posts list.";
$who{'77'} = "repairs all boards and topics.";
$who{'78'} = "rebuilds currently the members list.";
$who{'79'} = "deletes all his Instant Messages.";
$who{'80'} = "edits the Ban-List.";
$who{'81'} = "edits currently the Colors/Effects of the Membernames.";
$who{'82'} = "sends the thread";
$who{'83'} = "is viewing the Log-File.";
$who{'84'} = "is viewing his Notify List.";
$who{'85'} = "is searching for Members assigned to a MemberGroup.";
$who{'86'} = "recounts all board totals.";
$who{'87'} = "is viewing the last posts of";
$who{'88'} = "adds Smilies to the list.";
$who{'89'} = "deletes the Log-File of the Admin-Registrations.";
$who{'90'} = "is viewing the Admin-Registrations Log-File.";
$who{'91'} = "rates a thread.";
$who{'92'} = "is viewing the hidden info of";
$who{'93'} = "is viewing the Forum Index of";
$who{'94'} = "tries to register without any success.";
$who{'95'} = "reads that the board is closed for new registrations.";
$who{'96'} = "is on the login screen.";
$who{'97'} = "stares currently - not believing he can't login to the board - on the login screen.";
$who{'98'} = "There are currently";
$who{'99'} = "It's currently";
$who{'100'} = "user on the board.";
$who{'101'} = "Turn off the Online Overview";
$who{'102'} = "Enable Online Overview for all";
$who{'103'} = "Enable Online Overview just for Admins";
$who{'104'} = "Disable Admin Actions in Online Overview";
$who{'105'} = "Guest";
$who{'106'} = "Hidden";
</add after>

<edit file>
YaBB.pl
</edit file>

<search for>
	elsif ($action eq 'usersrecentposts') { require "$sourcedir/Profile.pl"; &usersrecentposts; }
</search for>

<add after>
	elsif ($action eq 'who') { require "$sourcedir/Who.pl"; &who; }
</add after>

<edit file>
Sources/Subs.pl
</edit file>

<search for>
	$date = "$mon_num/$mday/$saveyear $txt{'107'} $hour\:$min\:$sec";
</search for>

<add after>
	$logdate = "$mon_num.$mday.$saveyear $txt{'107'} $hour\:$min\:$sec";
</add after>

<search for>
sub WriteLog {
	fopen(LOG, "$vardir/log.txt");
	@entries = <LOG>;
	fclose(LOG);
	fopen(LOG, ">$vardir/log.txt", 1);
	$field="$username";
	if($field eq "Guest") { $field = "$ENV{'REMOTE_ADDR'}"; }
	print LOG "$field\|$date\n";
	foreach $curentry (@entries) {
		$curentry =~ s/\n//g;
		($name, $value) = split(/\|/, $curentry);
		$date1="$value";
		$date2="$date";
		&calctime;
		if($name ne "$field" && $result <= 15 && $result >= 0) { print LOG "$curentry\n"; }
	}
	fclose(LOG);
}
</search for>

<replace>
sub WriteLog {
open(LOG, "$vardir/log.txt");
@entries = <LOG>;
close(LOG);

open(LOG, ">$vardir/log.txt");
$field="$username";
my $iplog = "$ENV{'REMOTE_ADDR'}";
if($field eq "Guest") { $field = "$ENV{'REMOTE_ADDR'}"; }
print LOG "$field\|$logdate\|$date\|$username\|$INFO{'board'}\|$INFO{'action'}\|$INFO{'username'}\|$INFO{'num'}|$iplog\n";
foreach $curentry (@entries) {
        $curentry =~ s/\n//g;
        ($name, $value, $name1, $name2, $name3, $name4, $name5, $name6, $ipinfo) = split(/\|/, $curentry);
        $date1="$value";
        $date2="$logdate";
        &calctime;
        if($name ne "$field" && $result <= 2 && $result >= 0 && $name ne "$ENV{'REMOTE_ADDR'}") {
                print LOG "$curentry\n";
        }
}
close(LOG);
}
</replace>